using System;
using System.Web.UI.WebControls;
using System.Web.UI;

using System.IO;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this.BindGrid();
        }
    }

    private void BindGrid()
    {
        string conString = ConfigurationManager.ConnectionStrings["conString"].ConnectionString;
        using (SqlConnection con = new SqlConnection(conString))
        {
            using (SqlDataAdapter sda = new SqlDataAdapter("SELECT * FROM Customers", con))
            {
                using (DataTable dt = new DataTable())
                {
                    sda.Fill(dt);
                    GridView1.DataSource = dt;
                    GridView1.DataBind();
                }
            }
        }
    }

    protected void OnPageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        GridView1.PageIndex = e.NewPageIndex;
        this.BindGrid();
    }

    protected void PrintGridView(object sender, EventArgs e)
    {
        //Disable Paging if all Pages need to be Printed.
        if ((sender as Button).CommandArgument == "All")
        {
            //Disable Paging.
            GridView1.AllowPaging = false;

            //Re-bind the GridView.
            this.BindGrid();

            //For Printing Header on each Page.
            GridView1.UseAccessibleHeader = true;
            GridView1.HeaderRow.TableSection = TableRowSection.TableHeader;
            GridView1.FooterRow.TableSection = TableRowSection.TableFooter;
            GridView1.Attributes["style"] = "border-collapse:separate";
            foreach (GridViewRow row in GridView1.Rows)
            {
                if ((row.RowIndex + 1) % GridView1.PageSize == 0 && row.RowIndex != 0)
                {
                    row.Attributes["style"] = "page-break-after:always;";
                }
            }
        }
        else
        {
            //Hide the Pager.
            GridView1.PagerSettings.Visible = false;
            this.BindGrid();
        }

        using (StringWriter sw = new StringWriter())
        {
            //Render GridView to HTML.
            HtmlTextWriter hw = new HtmlTextWriter(sw);
            GridView1.RenderControl(hw);

            //Enable Paging.
            GridView1.AllowPaging = true;
            this.BindGrid();


            //Remove single quotes to avoid JavaScript error.
            string gridHTML = sw.ToString().Replace(Environment.NewLine, "");
            string gridCSS = gridStyles.InnerText.Replace("\"", "'").Replace(Environment.NewLine, "");


            //Print the GridView.
            string script = "window.onload = function() { PrintGrid('" + gridHTML + "', '" + gridCSS + "'); }";
            ClientScript.RegisterStartupScript(this.GetType(), "GridPrint", script, true);
        }
    }

    public override void VerifyRenderingInServerForm(Control control)
    {
        /*Verifies that the control is rendered */
    }
}
