Imports System.Data
Imports System.Data.SqlClient
Imports System.IO
Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim conString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Using con As New SqlConnection(conString)
            Using sda As New SqlDataAdapter("SELECT * FROM Customers", con)
                Using dt As New DataTable()
                    sda.Fill(dt)
                    GridView1.DataSource = dt
                    GridView1.DataBind()
                End Using
            End Using
        End Using
    End Sub

    Protected Sub OnPageIndexChanging(sender As Object, e As GridViewPageEventArgs)
        GridView1.PageIndex = e.NewPageIndex
        Me.BindGrid()
    End Sub

    Protected Sub PrintGridView(ByVal sender As Object, ByVal e As EventArgs)
        'Disable Paging if all Pages need to be Printed.
        If (CType(sender, Button).CommandArgument = "All") Then

            'Disable Paging.
            GridView1.AllowPaging = False

            'Re-bind the GridView.
            Me.BindGrid()

            'For Printing Header on each Page.
            GridView1.UseAccessibleHeader = True
            GridView1.HeaderRow.TableSection = TableRowSection.TableHeader
            GridView1.FooterRow.TableSection = TableRowSection.TableFooter
            GridView1.Attributes("style") = "border-collapse:separate"
            For Each row As GridViewRow In GridView1.Rows
                If (row.RowIndex + 1) Mod GridView1.PageSize = 0 AndAlso row.RowIndex <> 0 Then
                    row.Attributes("style") = "page-break-after:always;"
                End If
            Next
        Else
            'Hide the Pager.
            GridView1.PagerSettings.Visible = False
            Me.BindGrid()
        End If

        Using sw As StringWriter = New StringWriter

            'Render GridView to HTML.
            Dim hw As HtmlTextWriter = New HtmlTextWriter(sw)
            GridView1.RenderControl(hw)

            'Enable Paging.
            GridView1.AllowPaging = True
            Me.BindGrid()

            'Remove single quotes to avoid JavaScript error.
            Dim gridHTML As String = sw.ToString.Replace(Environment.NewLine, "")
            Dim gridCSS As String = gridStyles.InnerText.Replace("""", "'").Replace(Environment.NewLine, "")

            ' Print the GridView.
            Dim script As String = "window.onload = function() { PrintGrid('" & gridHTML & "', '" & gridCSS & "'); }"
            ClientScript.RegisterStartupScript(Me.GetType(), "GridPrint", script, True)
        End Using
    End Sub

    Public Overrides Sub VerifyRenderingInServerForm(control As Control)
        ' Verifies that the control is rendered
    End Sub
End Class
